{% extends 'base/summarized.html' %}
{% load mathfilters %}
{% load static %}

{% block base_title %}Trees generation{% endblock %}


{% block content %}
    <div class="jumbotron">
        <div>
            <h1>Trees generation</h1>
            <div class="lead">
                The <span class="font-italic">PKD</span> algorithm is an adaptation of the <span class="font-italic">KD-Tree</span> algorithm which recursively splits the space of skills in two until a terminaison criteria is met (number of splits).
            </div>

            <div class="d-flex flex-row justify-content-center">
                <img src="{% static 'imgs/tree2.png' %}">
            </div>

            <hr class="my-4">
        </div>

        <div>
            {% if object_list.count == 0 %}
                <div class="alert alert-info" role="alert">
                    No tree for now.
                    <hr>
                    Add a new tree with the "Add tree" button.
                </div>
            {% else %}
                {% include 'base/pagination.html' with page_obj=page_obj paginator=paginator%}

                <div class="row">
                    <div class="col-4">
                        <div class="list-group" id="myList" role="tablist">
                            {% for tree in object_list %}
                                <a class="list-group-item list-group-item-action {% if tree.id == object_list.0.id %}active{% endif %}" data-toggle="list" href="#w_{{ tree.id }}" role="tab">
                                    <div class="d-flex">
                                        <div>
                                            Tree : {{ tree.id }}
                                        </div>
                                        <div class="ml-auto">
                                            {% if tree.generating %}
                                                <span class="badge badge-pill badge-warning" id="tree_{{ tree.id }}_list">
                                                    Generating ({{ tree.current }}/{{ tree.expected }})
                                                </span>
                                            {% else %}
                                                <span class="badge badge-pill badge-success">Complete</span>
                                            {% endif %}
                                        </div>
                                    </div>
                                </a>

                            {% endfor %}
                        </div>
                    </div>

                    <div class="col-8">
                        <div class="tab-content">
                            {% for tree in object_list %}
                                <div class="tab-pane {% if tree.id == object_list.0.id %}active{% endif %}" id="w_{{ tree.id }}" role="tabpanel">
                                    <div class="d-flex bd-highlight mb-2">
                                        <div class="p-2 bd-highlight">
                                            <h3 class="font-weight-bold">Tree {{ tree.id }}</h3>
                                        </div>

                                        <div>
                                            {% if tree.generating %}
                                                <span class="badge badge-pill badge-warning" id="tree_{{ tree.id }}_table">
                                                    Generating ({{ tree.current }}/{{ tree.expected }})
                                                </span>
                                            {% else %}
                                                <span class="badge badge-pill badge-success">Complete</span>
                                            {% endif %}
                                        </div>

                                        {% if not tree.generating %}
                                            <div class="ml-auto p-1">
                                                <a href="{% url 'trees-get' tree.id %}">
                                                    <button class="btn btn-primary">View</button>
                                                </a>
                                            </div>

                                            <div class="p-1 bd-highlight">
                                                <a href="{% url 'trees-del' tree.id %}">
                                                    <button class="btn btn-danger">Remove</button>
                                                </a>
                                            </div>
                                        {% endif %}
                                    </div>
                                    <hr>

                                    <div class="d-flex flex-column">
                                        <div class="p-1">
                                            Start time : {{ tree.time_start }}
                                        </div>
                                        {% if not tree.generating %}
                                            <div class="p-1 ml-3">End time : {{ tree.time_end }}</div>
                                        {% endif %}
                                        <div class="p-1">
                                            Epsilon : {{ tree.epsilon }}
                                        </div>
                                        <div class="p-1">
                                            Tree height : {{ tree.prof_max }}
                                        </div>
                                        <div class="p-1">
                                            Number of bins : {{ tree.bins }}
                                        </div>
                                    </div>
                                </div>
                            {% endfor %}
                         </div>
                    </div>
                </div>
            {% endif %}
            <hr />
        </div>

        <div>
            <div class="d-flex bd-highlight mb-3">
                <div class="p-2 bd-highlight">
                    <a href="{% url 'trees-add' %}">
                        <button type="button" class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="New tree">
                            New tree
                        </button>
                    </a>
                </div>
                {% if object_list.count is not 0 %}
                    <div class="p-2 bd-highlight">
                        <a href="{% url 'trees-del-all' %}">
                            <button class="btn btn-danger" data-toggle="tooltip" data-placement="top" title="Remove all trees">
                                Remove all
                            </button>
                        </a>
                    </div>
                {% endif %}
                <div class="ml-auto p-2 bd-highlight">
                    <form method="post">
                        {% csrf_token %}
                        <button class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="Task generation">
                            Next
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <script>
        $('#myList a').on('click', function (e) {
            e.preventDefault()
            $(this).tab('show')
        });
        var timeout_interval = 2000;

        {% for tree in object_list %}
            {% if tree.generating %}
                function tree_{{ tree.id }}_gen() {
                    fetch("{% url 'trees-get-info' tree.id %}")
                        .catch((err) => { console.log(err); })
                        .then((res) => res.json())
                        .catch((err) => { console.log(err); })
                        .then((data) => {
                            var node_list = $('#tree_{{ tree.id }}_list');
                            var node_table = $('#tree_{{ tree.id }}_table');

                            var classes = "badge badge-pill badge-success";
                            var text = "Complete";

                            if (!data.generating) {
                                location.reload();
                            }

                            text = "Generating (" + data.current.toString() + "/" + data.expected.toString() + ")";
                            node_list.text(text);
                            node_table.text(text);
                            setTimeout(tree_{{ tree.id }}_gen, timeout_interval);
                        });
                }

                setTimeout(tree_{{ tree.id }}_gen, timeout_interval);
            {% endif %}

        {% endfor %}
    </script>
{% endblock %}